# refptr.h File Reference

`#include <gwenhywfar/types.h>`
`#include <gwenhywfar/gwenhywfarapi.h>`

Go to the source code of this file.

## Prototypes for Virtual Functions

typedef void *(* | GWEN_REFPTR_INFO_DUP_FN )(void *dp)
typedef void(* | GWEN_REFPTR_INFO_FREE_FN )(void *dp)

## Getting and Setting Flags

void | GWEN_RefPtr_AddFlags (GWEN_REFPTR *rp, GWEN_TYPE_UINT32 fl)
void | GWEN_RefPtr_DelFlags (GWEN_REFPTR *rp, GWEN_TYPE_UINT32 fl)
GWEN_TYPE_UINT32 | GWEN_RefPtr_GetFlags (const GWEN_REFPTR *rp)
void | GWEN_RefPtr_SetFlags (GWEN_REFPTR *rp, GWEN_TYPE_UINT32 fl)

## Constructor, Destructor, Copy, Duplicate functions

GWEN_REFPTR * | GWEN_RefPtr_copy (const GWEN_REFPTR *rp)
GWEN_REFPTR * | GWEN_RefPtr_dup (const GWEN_REFPTR *rp)
void | GWEN_RefPtr_free (GWEN_REFPTR *rp)
GWEN_REFPTR * | GWEN_RefPtr_new (void *dp, GWEN_REFPTR_INFO *rpi)

## Data Functions

void * | GWEN_RefPtr_GetData (const GWEN_REFPTR *rp)
void | GWEN_RefPtr_SetData (GWEN_REFPTR *rp, void *dp, GWEN_REFPTR_INFO *rpi)

## Getting and Setting Flags

These flags are used for newly created GWEN_REFPTR to provide a default value. Please see GWEN_REFPTR_FLAGS_AUTODELETE and following.
void | GWEN_RefPtrInfo_AddFlags (GWEN_REFPTR_INFO *rpi, GWEN_TYPE_UINT32 fl)
void | GWEN_RefPtrInfo_DelFlags (GWEN_REFPTR_INFO *rpi, GWEN_TYPE_UINT32 fl)
GWEN_TYPE_UINT32 | GWEN_RefPtrInfo_GetFlags (const GWEN_REFPTR_INFO *rpi)
void | GWEN_RefPtrInfo_SetFlags (GWEN_REFPTR_INFO *rpi, GWEN_TYPE_UINT32 fl)

## Constructor, Destructor, Copy, Duplicate functions

void | GWEN_RefPtrInfo_Attach (GWEN_REFPTR_INFO *rpi)
void | GWEN_RefPtrInfo_free (GWEN_REFPTR_INFO *rpi)
GWEN_REFPTR_INFO * | GWEN_RefPtrInfo_new ()

## Setters for Virtual Functions

void | GWEN_RefPtrInfo_SetDupFn (GWEN_REFPTR_INFO *rpi, GWEN_REFPTR_INFO_DUP_FN f)
void | GWEN_RefPtrInfo_SetFreeFn (GWEN_REFPTR_INFO *rpi, GWEN_REFPTR_INFO_FREE_FN f)

## Defines

#define | GWEN_REFPTR_FLAGS_AUTODELETE 0x00000001

## Typedefs

typedef GWEN_REFPTR | GWEN_REFPTR
typedef GWEN_REFPTR_INFO | GWEN_REFPTR_INFO

## Define Documentation

#define GWEN_REFPTR_FLAGS_AUTODELETE 0x00000001

## Typedef Documentation

typedef struct GWEN_REFPTR GWEN_REFPTR

typedef struct GWEN_REFPTR_INFO GWEN_REFPTR_INFO